/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VMaelstromDefRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VMaelstromDef extends TableImpl<VMaelstromDefRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_maelstrom_def</code>
     */
    public static final VMaelstromDef V_MAELSTROM_DEF = new VMaelstromDef();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VMaelstromDefRecord> getRecordType() {
        return VMaelstromDefRecord.class;
    }

    /**
     * The column <code>common_dd.v_maelstrom_def.taxonomy</code>.
     */
    public final TableField<VMaelstromDefRecord, String> TAXONOMY = createField(DSL.name("taxonomy"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_maelstrom_def.catalogue</code>.
     */
    public final TableField<VMaelstromDefRecord, String> CATALOGUE = createField(DSL.name("catalogue"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_maelstrom_def.term</code>.
     */
    public final TableField<VMaelstromDefRecord, String> TERM = createField(DSL.name("term"), SQLDataType.CLOB, this, "");

    private VMaelstromDef(Name alias, Table<VMaelstromDefRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VMaelstromDef(Name alias, Table<VMaelstromDefRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_maelstrom_def" as  WITH x(key, term) AS (
                SELECT DISTINCT t_core_annotation.key,
                   t_core_annotation.value
                  FROM common_dd.t_core_annotation
               )
        SELECT split_part(key, '::'::text, 1) AS taxonomy,
           split_part(key, '::'::text, 2) AS catalogue,
           term
          FROM x;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_maelstrom_def</code> table reference
     */
    public VMaelstromDef(String alias) {
        this(DSL.name(alias), V_MAELSTROM_DEF);
    }

    /**
     * Create an aliased <code>common_dd.v_maelstrom_def</code> table reference
     */
    public VMaelstromDef(Name alias) {
        this(alias, V_MAELSTROM_DEF);
    }

    /**
     * Create a <code>common_dd.v_maelstrom_def</code> table reference
     */
    public VMaelstromDef() {
        this(DSL.name("v_maelstrom_def"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VMaelstromDef as(String alias) {
        return new VMaelstromDef(DSL.name(alias), this);
    }

    @Override
    public VMaelstromDef as(Name alias) {
        return new VMaelstromDef(alias, this);
    }

    @Override
    public VMaelstromDef as(Table<?> alias) {
        return new VMaelstromDef(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VMaelstromDef rename(String name) {
        return new VMaelstromDef(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VMaelstromDef rename(Name name) {
        return new VMaelstromDef(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VMaelstromDef rename(Table<?> name) {
        return new VMaelstromDef(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromDef where(Condition condition) {
        return new VMaelstromDef(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromDef where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromDef where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromDef where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMaelstromDef where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMaelstromDef where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMaelstromDef where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMaelstromDef where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromDef whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromDef whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
